#ifdef __cplusplus                                                          
extern "C" {                            
#endif                                   

#ifndef NULL
#define NULL 0
#endif
#define DELETED -2

extern int triangulate;
extern int sorted; 
extern int plot;
extern int debug;

struct	Freenode	{
  struct	Freenode	*nextfree;
};

struct	Freelist	{
  struct	Freenode	*head;
  int			nodesize;
};

void freeinit(struct Freelist *fl, int size);
void makefree(struct Freenode *curr, struct Freelist *fl);
char *getfree(struct Freelist *fl);
//char *malloc();
char *myalloc(unsigned n);

extern float xmin;
extern float xmax;
extern float ymin;
extern float ymax;
extern float deltax;
extern float deltay;


struct Point	{
  float x,y;
};

/* structure used both for sites and for vertices */
struct Site	{
  struct	Point	coord;
  int		sitenbr;
  int		refcnt;
};

void ref(struct Site *v);
void deref(struct Site *v);
void makevertex(struct Site *v);

extern struct	Site	*sites;
extern int		nsites;
extern int		siteidx;
extern int		sqrt_nsites;
extern int		nvertices;
extern struct 	Freelist sfl;
extern struct	Site	*bottomsite;


struct Edge	{
  float		a,b,c;
  struct	Site 	*ep[2];
  struct	Site	*reg[2];
  int		edgenbr;
};

struct Halfedge {
  struct Halfedge	*ELleft, *ELright;
  struct Edge	*ELedge;
  int		ELrefcnt;
  char		ELpm;
  struct	Site	*vertex;
  float		ystar;
  struct	Halfedge *PQnext;
};


#define le 0
#define re 1
extern int nedges;
extern struct Freelist efl;

//int has_endpoint();
void endpoint(struct Edge *e, int lr, struct Site *s);
int right_of(struct Halfedge *el, struct Point *p);
struct Site *intersect(struct Halfedge *el1, struct Halfedge *el2);
//struct Site *intersect(struct Halfedge *el1, struct Halfedge *el2, struct Point *p);
float dist(struct Site *s, struct Site *t);
struct Edge *bisect(struct Site *s1, struct Site *s2);

extern struct   Freelist	hfl;
extern struct	Halfedge *ELleftend, *ELrightend;
extern int 	ELhashsize;
extern struct	Halfedge **ELhash;
struct	Halfedge *HEcreate(struct Edge *e, int pm);
void ELinitialize(void);
void ELinsert(struct Halfedge *lb, struct Halfedge *New);
void ELdelete(struct Halfedge *he);
struct	Halfedge *ELleft(struct Halfedge *he);
struct	Halfedge *ELright(struct Halfedge *he);
struct	Halfedge *ELleftbnd(struct Point *p);
struct	Site *leftreg(struct Halfedge *he);
struct	Site *rightreg(struct Halfedge *he);


extern int PQhashsize;
extern struct Halfedge *PQhash;
//struct Halfedge *PQfind();
extern int PQcount;
extern int PQmin;
int PQempty(void);
void PQinitialize(void);
void PQdelete(struct Halfedge *he);
void PQinsert(struct Halfedge *he, struct Site *v, float offset);
struct Point PQ_min(void);
struct Halfedge *PQextractmin(void);

void out_ep(struct Edge *e);

#ifdef __cplusplus
}
#endif

